// Equip sounds
datablock AudioProfile(ThrowableCatEquip01Sound) {
   filename    = "./catEquip01.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(ThrowableCatEquip02Sound) {
   filename    = "./catEquip02.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(ThrowableCatEquip03Sound) {
   filename    = "./catEquip03.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(ThrowableCatEquip04Sound) {
   filename    = "./catEquip04.wav";
   description = AudioClose3d;
   preload = true;
};

// Throw sounds
datablock AudioProfile(ThrowableCatThrow01Sound) {
   filename    = "./catThrow01.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(ThrowableCatThrow02Sound) {
   filename    = "./catThrow02.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(ThrowableCatThrow03Sound) {
   filename    = "./catThrow03.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(ThrowableCatThrow04Sound) {
   filename    = "./catThrow04.wav";
   description = AudioClose3d;
   preload = true;
};

// Collide sounds
datablock AudioProfile(ThrowableCatCollide01Sound) {
   filename    = "./catCollide01.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(ThrowableCatCollide02Sound) {
   filename    = "./catCollide02.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(ThrowableCatCollide03Sound) {
   filename    = "./catCollide03.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(ThrowableCatCollide04Sound) {
   filename    = "./catCollide04.wav";
   description = AudioClose3d;
   preload = true;
};


//effects
datablock ParticleData(ThrowableCatExplosionParticle) {
  dragCoefficient    = 3.0;
  windCoefficient    = 0.0;
  gravityCoefficient  = 0.5;
  inheritedVelFactor  = 0.0;
  constantAcceleration  = 0.0;
  lifetimeMS    = 900;
  lifetimeVarianceMS  = 300;
  spinSpeed    = 10.0;
  spinRandomMin    = -50.0;
  spinRandomMax    = 50.0;
  useInvAlpha    = true;
  animateTexture    = false;
  //framesPerSec    = 1;

  textureName    = "base/data/particles/cloud";
  //animTexName    = "~/data/particles/cloud";

  // Interpolation variables
  colors[0]  = "1 1 1 1";
  colors[1]  = "0.9 0.9 0.9 1";
  sizes[0]  = 4.0;
  sizes[1]  = 3.0;
  sizes[2]  = 1.0;
  times[0]  = 0.0;
  times[1]  = 1.0;
};

datablock ParticleEmitterData(ThrowableCatExplosionEmitter) {
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   lifeTimeMS     = 21;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "ThrowableCatExplosionParticle";

   uiName = "Throwable Cat Fur";
   emitterNode = TenthEmitterNode;
};

datablock ExplosionData(ThrowableCatExplosion) {
   //explosionShape = "";
   lifeTimeMS = 150;

   soundProfile = deathExplosionSound;

   emitter[0] = ThrowableCatExplosionEmitter;
   //particleDensity = 30;
   //particleRadius = 1.0;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "7.0 8.0 7.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 15.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;

   //impulse
   impulseRadius = 0.5;
   impulseForce = 1;

   //radius damage
   radiusDamage        = 0;
   damageRadius        = 0;
};

// Projectile
AddDamageType("ThrowableCatDirect", '<bitmap:Add-Ons/Weapon_ThrowableCat/CI_throwableCat> %1', '%2 <bitmap:Add-Ons/Weapon_ThrowableCat/CI_throwableCat> %1', 1, 1);
datablock ProjectileData(ThrowableCatProjectile) {
   projectileShapeName = "./kitten.dts";
   directDamage        = 15;
   directDamageType  = $DamageType::ThrowableCatDirect;
   impactImpulse     = 250;
   verticalImpulse     = 500;
   explosion           = ThrowableCatExplosion;

   brickExplosionRadius = 0;
   brickExplosionImpact = false; //destroy a brick if we hit it directly?
   brickExplosionForce  = 0;
   brickExplosionMaxVolume = 0;
   brickExplosionMaxVolumeFloating = 0;

   muzzleVelocity      = 35;
   velInheritFactor    = 1;

   armingDelay         = 2000;
   lifetime            = 3000;
   fadeDelay           = 1000;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.45;
   isBallistic         = true;
   gravityMod = 1;
   explodeOnDeath = true;

   hasLight    = false;

   uiName = "Throwable Cat";
};


//////////
// item //
//////////
datablock ItemData(ThrowableCatItem) {
  category = "Weapon";  // Mission editor category
  className = "Weapon"; // For inventory system

   // Basic Item Properties
  shapeFile = "./kitten.dts";
  mass = 1;
  density = 0.2;
  elasticity = 0.2;
  friction = 0.6;
  emap = true;

  //gui stuff
  uiName = "Throwable Cat";
  iconName = "./icon_throwableCat";
  doColorShift = true;
  colorShiftColor = "1 1 1 1";

   // Dynamic properties defined by the scripts
  image = ThrowableCatImage;
  canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ThrowableCatImage) {
   // Basic Item properties
   shapeFile = "./kitten.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0.2";
   eyeOffset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = ThrowableCatItem;
   ammo = " ";
   projectile = ThrowableCatProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "1 1 1 1";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
  stateName[0]      = "Activate";
  stateTimeoutValue[0]    = 0.1;
  stateTransitionOnTimeout[0]  = "Ready";
  stateSequence[0]    = "ready";
  stateScript[0]      = "onReady";

  stateName[1]      = "Ready";
  stateTransitionOnTriggerDown[1]  = "Charge";
  stateAllowImageChange[1]  = true;
  
  stateName[2]                    = "Charge";
  stateTransitionOnTimeout[2]  = "Armed";
  stateTimeoutValue[2]            = 0.7;
  stateWaitForTimeout[2]    = false;
  stateTransitionOnTriggerUp[2]  = "AbortCharge";
  stateScript[2]                  = "onCharge";
  stateAllowImageChange[2]        = false;
  
  stateName[3]      = "AbortCharge";
  stateTransitionOnTimeout[3]  = "Ready";
  stateTimeoutValue[3]    = 0.3;
  stateWaitForTimeout[3]    = true;
  stateScript[3]      = "onAbortCharge";
  stateAllowImageChange[3]  = false;

  stateName[4]      = "Armed";
  stateTransitionOnTriggerUp[4]  = "Fire";
  stateAllowImageChange[4]  = false;

  stateName[5]      = "Fire";
  stateTransitionOnTimeout[5]  = "Ready";
  stateTimeoutValue[5]    = 0.5;
  stateFire[5]      = true;
  stateSequence[5]    = "fire";
  stateScript[5]      = "onFire";
  stateWaitForTimeout[5]    = true;
  stateAllowImageChange[5]  = false;
  stateSound[5]        = "";
};

function ThrowableCatImage::onReady(%this, %obj, %slot) {
  ThrowableCat_PlayRandomSound("Equip", %obj.getTransform());
}

function ThrowableCatImage::onCharge(%this, %obj, %slot) {
  %obj.playthread(2, SpearReady);
}

function ThrowableCatImage::onAbortCharge(%this, %obj, %slot) {
  %obj.playthread(2, root);
}

function ThrowableCatImage::onFire(%this, %obj, %slot) {
  %client = %obj.client;
  
  if (isObject(%client)) {
    %obj.tool[%obj.currTool] = 0;
    %obj.weaponCount--;
    
    messageClient(%client, 'MsgItemPickup', '', %obj.currTool, 0);
    serverCmdUnUseTool(%client);
    %obj.updateArm(0);
    %obj.unmountImage(0);
  }

  %obj.playthread(2, SpearThrow);
  ThrowableCat_PlayRandomSound("Throw", %obj.getTransform());

  Parent::onFire(%this, %obj, %slot);
}

function ThrowableCat_PlayRandomSound(%type, %pos) {
  %sound = "ThrowableCat" @ %type @ "0" @ getRandom(1, 4) @ "Sound";

  if (isObject(%sound)) {
    ServerPlay3d(%sound, %pos);
  }
}

package Weapon_ThrowableCat {
  function ThrowableCatProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal) {
    if (%obj.lastCatSound $= "" || getSimTime() - %obj.lastCatSound > 4000) {
      %obj.lastCatSound = getSimTime();
      ThrowableCat_PlayRandomSound("Collide", %pos);
    }

    Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
  }

  function Armor::onCollision(%this, %obj, %col, %vec, %force) {
    if (%col.getDataBlock() == ThrowableCatItem.getID() && %col.canPickup) {
      for (%i = 0; %i < %this.maxTools; %i++) {
        %item = %obj.tool[%i];

        if (!isObject(%item)) {
          %obj.pickup(%col);
          break;
        }
      }
    }
    
    Parent::onCollision(%this, %obj, %col, %vec, %force);
  }
};
activatePackage(Weapon_ThrowableCat);